import java.applet.*;
import java.awt.*;
import java.lang.*;

public class TrackCanvas extends Canvas {
	show_result smain;
	int x1, y1, x2, y2, flag;
	Image map, ac, radar, airbase, threat, interceptor;
	double coords[][] = new double[2][2];
	int his[][] = new int [10][2];
        
	adl currApplet;
	boolean first = true;

	TrackCanvas(show_result smain) {
		System.out.println("In TrackCanvas()...");
		this.currApplet = smain.currApplet;  // <-- B.Ye, April/20th/98

		this.smain = smain;
//		reshape(0, 0, 900, 600);
		map = currApplet.getImage(currApplet.getCodeBase(), "./civFigures/CE.jpg");
//		airbase = currApplet.getImage(currApplet.getCodeBase(), "./civFigures/airbase.gif");
		interceptor = currApplet.getImage(currApplet.getCodeBase(), "./civFigures/interceptor.gif");
		radar = currApplet.getImage(currApplet.getCodeBase(), "./civFigures/radar.gif");
		threat = currApplet.getImage(currApplet.getCodeBase(), "./civFigures/threat.gif");
		ac = currApplet.getImage(currApplet.getCodeBase(), "./civFigures/ac.gif");

		set_coordinate(-96, 48, -55, 36);
		flag = 2;

		first = true;
	}

	public void set_coordinate(int top_x, int top_y, int bot_x, int bot_y) {     
		coords[0][0] = top_x;
		coords[0][1] = top_y;
		coords[1][0] = bot_x;
		coords[1][1] = bot_y;
	}

	public boolean mouseDown(Event evt, int x , int y) {
		switch(flag) {
		case 1 :  /* from the North America region */
			if(  x <= 210 && y <= 85 ) {
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/Alaska.jpg");
				set_coordinate(-170, 70, -130, 54);
				flag = 0;
			}
			else if( x <= 525 && y <= 198 )	{
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/NW.jpg");
				set_coordinate(-145, 65, -96, 46);
				flag = 0;
			}

			else if( x <= 800 && y <= 198 ) {
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/NE.jpg");
				set_coordinate(-96, 65, -55, 46);
				flag = 0;
			}

			else if( x <= 525 && y <= 313 ) {
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/CW.jpg");
				set_coordinate(-130, 48, -96, 36);
				flag = 0;
			}

			else if( x <= 800 && y <= 313 ) {
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/CE.jpg");
				set_coordinate(-96,48, -55, 36);
				flag = 2;
			}

			else if( x <= 525 && y <= 500 ) {
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/SW.jpg");
				set_coordinate(-124, 40, -96, 24);
				flag = 0;
			}

			else if( x <= 800 && y <= 500 ) {
				map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/SE.jpg");
				flag = 0;
				set_coordinate(-96, 40, -55, 24);
			}
			break;
    
         case 2 :   /* from the CE region */
             if( x>=300 && x<=600 && y>=100 && y <=400 )
               { map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/N_east.jpg");
                 flag = 3;
                 set_coordinate(-80,46,-65,38);
                 }
              break;


        case 3 :   /* from the NorthEast region */
            if( x <= 400 && y<= 250 )
              { map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/N_east1.jpg");
                flag = 4;
                set_coordinate(-80,46,-71, 41);
               }
            else if( x <= 800 && y<= 250 )
              { map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/N_east2.jpg");
                flag = 4;
                set_coordinate(-74,46,-65, 41);
               }
            else if( x <= 400 && y<= 500 )
              { map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/N_east3.jpg");
                flag = 4;
                set_coordinate(-80,42,-71, 38);
               }
            else if( x <= 800 && y<= 500 )
              { map=currApplet.getImage(currApplet.getCodeBase(), "./civGIF/N_east4.jpg");
                flag = 4;
                set_coordinate(-74, 42,-65, 38);
               }
             break;
          } /* end of switch */


         repaint();
         return true;
         
    } /* end of MouseDown */

	public void paint1(Graphics g) {
		int i,j,t,k ;
		g = getGraphics();
 
		resize(800, 500);
 
		g.drawImage(map, 0, 0, this); //-- commented by B.Ye, April/26th/98
 
	} 

	public void paint(Graphics g) {
		int w = size().width;
		int h = size().height;

		int i, j, t, k;
		g = getGraphics();
//		resize(800, 500);

		g.drawImage(map, 0, 0, 800, 500, this);
  
		/* Interceptor flag is ON  */

		for ( i = 0 ; i < smain.NUM_AIRBASE ; i++) {  /* number of airbase */

			x2 = 0 + (int)Math.round(800 / (coords[1][0] - coords[0][0])
				* (smain.airbase_loc[i][0] - coords[0][0]));

			y2 = 500 - (int)Math.round(500 / (coords[0][1] - coords[1][1])
				* (smain.airbase_loc[i][1] - coords[1][1]));

//			System.out.println("draw airbase");
//			g.drawImage(airbase, x2, y2, this);
/**/
			g.setColor(Color.green);
			g.fillRect(x2, y2, 32, 24);
/**/
			/* Interceptor flag is ON  */
			if(smain.Interceptorflag == 1) {
				x1 = 0 + (int)Math.round( 800 
					/ (coords[1][0] - coords[0][0])
					* (smain.ac_cur_location[0][0] - coords[0][0]));

				y1 = 500 - (int)Math.round( 500 
					/ (coords[0][1] - coords[1][1])
					* (smain.ac_cur_location[0][1] - coords[1][1]));

				if ( ( smain.ac_cur_location[0][0] != 0 ) &&
					( smain.ac_cur_location[0][1] != 0 ) ) {
					/* line from airbase to target */
					g.drawLine(x1, y1, x2, y2);
				}

				if ((smain.InterceptorLaunchedflag == 1) ||
					( smain.KillTargetflag == 1)) {
					/* Intercepter Launched  or  
						KillTaget flag setted*/

					/* which AirBase  */
					if(smain.airbaseflag[i] == 1 ) {
						x1 = 0 + (int)Math.round(800 / 
						(coords[1][0] - coords[0][0])
							* (smain.Interceptor_location[i][0] - coords[0][0]));
						y1 = 500 - (int)Math.round(500 /
						(coords[0][1] - coords[1][1])
							* (smain.Interceptor_location[i][1] - coords[1][1]));
						g.setColor(Color.green);
						/* line from airbase 
							to interceptor  */
						if((smain.Interceptor_location[i][0] == 0) && 
							(smain.Interceptor_location[i][1] == 0)) 
							continue;
						g.setColor(Color.red);
						g.drawLine(x1, y1, x2, y2);

						g.drawImage(interceptor, x1, y1, this);
					}/* end which AirBase */
				} /* End of InterceptorLaunched flag */

			} /* End of Interceptor flag */

		}/* end for airbase  */ 

		for ( i = 0; i < smain.NUM_RADAR; i++) { /* the number of radar*/
		
			if (smain.rflag[i] == 1) { /*radar is alive */
				g.setColor(Color.green);

				/* coordinate of radar(x2, y2) */
				x2 = 0 + (int)Math.round(800 / (coords[1][0] - coords[0][0])
					* (smain.radar_loc[i][0] - coords[0][0]));

				y2 = 500 - (int)Math.round(500 / (coords[0][1] - coords[1][1])
					* (smain.radar_loc[i][1] - coords[1][1]));

				g.drawImage(radar, x2, y2, this);
/**
				if ( i == smain.NUM_RADAR - 1) {
					if (flag == 2) 
						aegis = currApplet.getImage(currApplet.getCodeBase(), "./civGIF/aegis2.gif");
					else if (flag == 3)
						aegis = currApplet.getImage(currApplet.getCodeBase(), "./civGIF/aegis3.gif");
					else if (flag == 4)
						aegis = currApplet.getImage(currApplet.getCodeBase(), "./civGIF/aegis4.gif");
					g.drawImage(aegis, x2, y2, this);
				}
				else {
					if (flag == 2) g.fillOval(x2,y2,4, 4);
					else if (flag == 3) g.fillOval(x2,y2,6, 6);
					else if (flag == 4) g.fillOval(x2,y2,8, 8);
				}
**/

				for ( j = 0 ; j < smain.NUM_AC ; j++ ) { /* the number of aircraft*/

					if((smain.ac_cur_location[j][0] == 0)&&(smain.ac_cur_location[j][1] == 0)) 
						continue;

					x1 = 0 + (int)Math.round(800 / (coords[1][0] - coords[0][0])
						* (smain.ac_cur_location[j][0] - coords[0][0]));

					y1 = 500 - (int)Math.round(500 / (coords[0][1] - coords[1][1])
						* (smain.ac_cur_location[j][1] - coords[1][1]));
					g.setColor(Color.blue);

					if (((smain.ac_cur_rae[i][j][0] <smain.maxrange) || (smain.maxrange <0))
						&& (smain.ac_cur_rae[i][j][2] >= smain.minelevation)) {
						g.drawLine(x1, y1, x2, y2);
						g.setColor(Color.magenta);

/**
						if ( j == 0 ) {
							if ( flag == 2 ) 
								ac = currApplet.getImage(currApplet.getCodeBase(), "./civGIF/ac2.gif");
							else if (flag == 3)
								ac = currApplet.getImage(currApplet.getCodeBase(), "./civGIF/ac3.gif");
							else if (flag == 4)
								ac = currApplet.getImage(currApplet.getCodeBase(), "./civGIF/ac4.gif");	
							g.drawImage(ac, x1, y1, this);
						}
						else {
							if(flag == 2)  g.fillOval(x1, y1, 2, 2);
							else if(flag == 3) g.fillOval(x1,y1,4, 4);
							else if(flag == 4) g.fillOval(x1,y1,6, 6);
						}
**/
						if ( j == 0 ) {
							g.drawImage(threat, x1, y1, this);
						}
						else {
							g.drawImage(ac, x1, y1, this);
						}
					}/* end if */

					/* Track histroy   */
					if ((smain.History == 1) && (smain.ac_cur_location[j][0] !=0 ) && 
						(smain.ac_cur_location[j][1] !=0)) {
						k = 0;

						while ((k<5) && (smain.ac_cur_location[j][2] >= smain.ac_loc[j][k][3])) {
							x1 = 0 + (int)Math.round(800 / (coords[1][0] - coords[0][0])
							* (smain.ac_loc[j][k][0] - coords[0][0]));

							y1 = 500 - (int)Math.round(500 / (coords[0][1] - coords[1][1]) 
							* (smain.ac_loc[j][k][1] - coords[1][1]));
							his[k][0]= x1;
							his[k][1]= y1;
							k++;
						}

						x1 = 0 + (int)Math.round(800 / (coords[1][0] - coords[0][0])
							* (smain.ac_cur_location[j][0] - coords[0][0]));

						y1 = 500 - (int)Math.round(500 / (coords[0][1] - coords[1][1])
							* (smain.ac_cur_location[j][1] - coords[1][1]));

						his[k][0]= x1;
						his[k][1]= y1;

						for ( t = 0 ; t < k ; t++ ) {
							g.setColor(Color.darkGray);
							g.drawLine(his[t][0],his[t][1],his[t+1][0],his[t+1][1]);
						}
					} /* end of track history */

				} /* end for aircraft */
			} /* end if radar is alive  */

			/* radar is dead */
			else {
				g.setColor(Color.red);
				g.fillOval(x2,y2,6,6);
			} /* radar availability */

		} /* end for radar */
	}/* paint() */
}




